#!/bin/bash

PWDIR=`pwd`
if [ `id|grep -c "root"` -eq 0 ]; then
	echo "rootで実行してください"
	exit
fi

source ./EpgRec_inst.conf || exit

if [ ${UBUNTU_UPGRADE} -eq 1 ]; then
	apt-get update
	apt-get upgrade
fi

apt-get install manpages-ja

apt-get install ntp
IFS=$'\n'
# /etc/ntp.conf にntpサーバーを設定する
#--------------------------------------
if [ `cat /etc/ntp.conf|grep -c "^server ${NTP_SERVER}"` -eq 0 ]; then
	ORG="/etc/ntp.conf.org"
	OUT="/etc/ntp.conf"
	cp -p $OUT $ORG
	echo -n > $OUT
	while read -r line; do
		if [ `echo "$line"|grep -c "^\# You do need to talk to an NTP server"` -ne 0 ]; then
			echo "$line" >> $OUT
			echo "server ${NTP_SERVER}" >> $OUT
		else
			echo "$line" >> $OUT
		fi
	done < $ORG
fi

service ntp restart
echo
echo "ntp -q"
ntpq -p

echo
echo "enter で続行します"
read keyinput

# デーモンのインストール
#-----------------------
apt-get install vsftpd
apt-get install samba
sysv-rc-conf ntp on
sysv-rc-conf vsftpd on
sysv-rc-conf smbd on

apt-get install apache2 php5 libapache2-mod-php5 php5-cli mysql-server php5-mysql
apt-get install at cron
sysv-rc-conf apache2 on
sysv-rc-conf mysql on
sysv-rc-conf atd on
sysv-rc-conf cron on

IFS=$'\n'
# /etc/passwdのwww-dataの/bin/falseを/bin/shに変える
#---------------------------------------------------
ORG="/etc/passwd.org"
OUT="/etc/passwd"
cp -p $OUT $ORG
echo -n > $OUT
while read -r line; do
	if [ `echo "$line"|grep -c "^www-data.*/bin/false$"` -ne 0 ]; then
		echo "$line"|sed 's/\/bin\/false$/\/bin\/sh/' >> $OUT
	else
		echo "$line" >> $OUT
	fi
done < $ORG

# /etc/at.denyからwww-dataを削除する
#-----------------------------------
ORG="/etc/at.deny.org"
OUT="/etc/at.deny"
cp -p $OUT $ORG
echo -n > $OUT
while read -r line; do
	if [ `echo "$line"|grep -c "www-data$"` -eq 0 ]; then
		echo "$line" >> $OUT
	fi
done < $ORG

# /etc/mysql/my.cnfに"default-character-set = utf8"を追加する
#------------------------------------------------------------
ORG="/etc/mysql/my.cnf.org"
OUT="/etc/mysql/my.cnf"
cp -p $OUT $ORG
echo -n > $OUT
while read -r line; do
	if [ `echo "$line"|grep -c "^default-character-set = utf8$"` -eq 0 ]; then
		echo "$line" >> $OUT
		if [ `echo "$line"|grep -c "^\[mysqld\]$"` -ne 0 ]; then
			echo "default-character-set = utf8" >> $OUT
		fi
		if [ `echo "$line"|grep -c "^\[mysql\]$"` -ne 0 ]; then
			echo "default-character-set = utf8" >> $OUT
		fi
	fi
done < $ORG

cd ${PWDIR}
#データーベースepgrecを作る
#--------------------------
echo
echo "データベース epgrec を作成します"
echo "create database ${MySQL_DB};" > sqlcmd
echo "grant all privileges on *.* to ${MySQL_USER}@localhost identified by '${MySQL_PSWD}';" >> sqlcmd
echo "exit" >> sqlcmd
mysql --user=root --password=${MySQL_ROOT_PSWD} <sqlcmd
rm sqlcmd

cd ${PWDIR}
rm GR_CHANNELS.conf
rm RECBYMAIL.conf

echo
echo "次のスクリプトを実行してください"
echo "./2_pcsc_PT2_recpt1_epgdump.sh"
echo

