#!/bin/bash

PWDIR=`pwd`
if [ `id|grep -c "root"` -eq 0 ]; then
	echo "rootで実行してください"
	exit
fi

source ./EpgRec_inst.conf || exit

if [ ! -d files ]; then
	mkdir files
fi
if [ ! -d /var/www ]; then
	mkdir /var/www
fi


# pcsc-tools driver
#=======================================
apt-get install libccid pcsc-tools libpcsclite-dev build-essential
if [ ! -f files/c44e16dbb0e2.zip ]; then
	cd files
	wget http://hg.honeyplanet.jp/pt1/archive/c44e16dbb0e2.zip
	cd ..
fi
echo
unzip files/c44e16dbb0e2.zip -d ${PWDIR}
cd pt1-c44e16dbb0e2/arib25/src && echo && make && make install
cd ${PWDIR} && rm -r pt1-c44e16dbb0e2
echo
echo "コマンド「pcsc_scan」でICカードリーダーの認識状態が確認できます"
#pcsc_scan

echo
echo "enter で続行します"
read keyinput


# PT2 driver
#=======================================
cd ${PWDIR}
# Ubuntu標準のドライバーを無効にする
if [ `cat /etc/modprobe.d/blacklist.conf|grep -c "^blacklist earth-pt1$"` -eq 0 ]; then
	echo "blacklist earth-pt1" >> /etc/modprobe.d/blacklist.conf
fi

apt-get install autoconf automake
if [ ! -f files/4d42c5c28557.tar.bz2 ]; then
	cd files
	wget http://hg.honeyplanet.jp/pt1/archive/4d42c5c28557.tar.bz2
	cd ..
fi
echo
tar -xvf files/4d42c5c28557.tar.bz2 -C ${PWDIR}
cd pt1-4d42c5c28557/driver && echo && make && make install
insmod /lib/modules/`uname -r`/kernel/drivers/video/pt1_drv.ko


# recpt1
#=======================================
cd ${PWDIR}
if [ ! -d pt1-4d42c5c28557/recpt1 ]; then
	if [ ! -f files/4d42c5c28557.tar.bz2 ]; then
		cd files
		wget http://hg.honeyplanet.jp/pt1/archive/4d42c5c28557.tar.bz2
		cd ..
	fi
	tar -xvf files/4d42c5c28557.tar.bz2 -C ${PWDIR}
fi
cd pt1-4d42c5c28557/recpt1
./autogen.sh
./configure -enable-b25
echo && make && make install
echo "/usr/local/lib" > /etc/ld.so.conf.d/recpt1.conf
ldconfig && ldd /usr/local/bin/recpt1
ls -lart /dev/ |grep pt1
cd ${PWDIR} && rm -r pt1-4d42c5c28557


# epgdump
#=======================================
cd ${PWDIR}
if [ ! -f files/epgdumpr2-utf8.tar.gz ]; then
	cd files
	wget http://www.sky.sannet.ne.jp/kn_ishi/epgrec/files/epgdumpr2-utf8.tar.gz
	cd ..
fi
echo
tar -zxvf files/epgdumpr2-utf8.tar.gz -C ${PWDIR}
cd epgdumpr2 && echo && make && cp epgdump /usr/local/bin
cd ${PWDIR} && rm -r epgdumpr2


cd ${PWDIR}
rm GR_CHANNELS.conf
rm RECBYMAIL.conf


echo
echo "再起動してから次のスクリプトを実行してください"
echo "./3_EpgRec.sh"
echo
echo "enter で再起動します"
read keyinput
reboot
