#!/bin/bash

PWDIR=`pwd`
if [ `id|grep -c "root"` -eq 0 ]; then
	echo "rootで実行してください"
	exit
fi

source ./EpgRec_inst.conf || exit

#miniDLNA
if [ ! -f files/minidlna_1.0.22_static.tar.gz ]; then
	cd files
	wget http://www.sky.sannet.ne.jp/kn_ishi/epgrec/files/minidlna_1.0.22_static.tar.gz
	cd ..
fi
echo
tar -zxvf files/minidlna_1.0.22_static.tar.gz -C ${PWDIR}
chmod 777 .
IFS=$'\n'
ORG="${PWDIR}/etc/minidlna.conf.org"
OUT="${PWDIR}/etc/minidlna.conf"
cp -p ${OUT} ${ORG}
echo -n > ${OUT}
while read -r line; do
	if [ `echo "${line}"|grep -c "^media_dir="` -ne 0 ]; then
		echo "media_dir=V,/var/www/epgrec/video" >> ${OUT}
	else
		if [ `echo "${line}"|grep -c "friendly_name="` -ne 0 ]; then
			if [ `echo "${line}"|grep -c "^friendly_name="` -eq 0 ]; then
				echo "${line}" >> ${OUT}
			fi
			echo "friendly_name=${DLNA_NAME}" >> ${OUT}
		else
			echo "${line}" >> ${OUT}
		fi
	fi
done < ${ORG}
chmod 644 ${OUT}
mv ${OUT} /etc
chmod 755 ${PWDIR}/usr/sbin/minidlna
mv ${PWDIR}/usr/sbin/minidlna /usr/sbin
rm -r ${PWDIR}/etc
rm -r ${PWDIR}/usr


echo
if [ ! -f files/minidlna_1.0.22_src.tar.gz ]; then
	cd files
	wget http://www.sky.sannet.ne.jp/kn_ishi/epgrec/files/minidlna_1.0.22_src.tar.gz
	cd ..
fi
echo
tar -zxvf files/minidlna_1.0.22_src.tar.gz -C ${PWDIR}
mv ${PWDIR}/minidlna-1.0.22/linux/minidlna.init.d.script /etc/init.d/minidlna
chmod 777 /etc/init.d/minidlna
sysv-rc-conf minidlna on
rm -r ${PWDIR}/minidlna-1.0.22

#SMplayer
echo
apt-get install smplayer


cd ${PWDIR}
rm GR_CHANNELS.conf
rm RECBYMAIL.conf


echo
echo "全てのインストールが終了しました"
echo "おわりです"
echo


