#!/usr/bin/php
<?php

//ライブラリ読み込み
require_once("Net/POP3.php");
require_once("Mail.php");
require_once("Mail/mime.php");

//設定読み込み
require_once dirname(__FILE__)."/recbymail.config.php";
if(DEBUGSW=="on"){
	echo("DEBUGSW = on\n");
	echo("System Encoding = mb_internal_encoding()\n");
	define("SMTP_DEBUG", true);
} else{
	define("SMTP_DEBUG", false);
}
$client = null;
function getRpc(){
	global $client;
	if($client == null){
		if(RPC_TYPE == 2){
			require_once dirname(__FILE__)."/xmlrpc.class.php";
			$client = new XmlRpc();
		} else {
			require_once dirname(__FILE__)."/httprpc.class.php";
			$client = new HttpRpc();
		}
	}
	return $client;
}

//POP3サーバーに接続
$pop = new Net_POP3();
$pop->connect(POP_HOST, POP_PORT);
$pop->login(POP_USER, POP_PSWD, "USER");

//メール受信＆リクエスト処理 ===============================
$messages = $pop->getListing();
if($messages){
        foreach($messages as $k => $row){
		$return=null;
		$request=null;
                $id = $row["msg_id"];
                $status = $pop->getMsg($id);
		preg_match("/Return-Path:.*<(.+)>.*/",$status,$matches);
		$return=$matches[1];
		preg_match("/Subject:(.+)/",$status,$matches);
		$request=mb_decode_mimeHeader(trim($matches[1]));
		if(DEBUGSW=="on"){
			echo("--- receivemail ---\n");
			echo($return."\n");
			echo($request."\n");
			echo("-------------------\n");
		}
		//リクエスト処理へ
		if( $return!=null and $request!=null ){
			proc_request($return,$request);
		}
        }
}
//メインループここまで ====================================
$pop->disconnect();


//リクエスト処理関数
function proc_request($return,$request){

	//録画予約
	if(preg_match("/TV!(\s)?(\(.+\))?((\d+)時)?(.+)録って/", $request, $matches) == 1){
		$channel=$matches[2];
		$hour   =$matches[4];
		$title  =$matches[5];
		$type   =null;
		if($channel && preg_match("/\((\[(.+)\])?(.*)\)/", $channel, $matches)){
			$type = $matches[2];
			$channel = $matches[3];
		}
		
		$rpc = getRpc();
		$results = $rpc->searchProgram($title, $type, $channel, $hour);
		
		if(count($results) == 0){
			$msg="そんな番組ないよ！ by 録るメーラー";
		} else if(count($results) > 1){
			$msg="もっと詳しく！ by 録るメーラー";
		} else {
			$result = $results[0];
			try{
				$rpc->reserveProgram($result["program_id"]);	
				$msg="予約したよ。 by 録るメーラー\r\n".$result["title"];
			} catch (Exception $e) {
				if(DEBUGSW=="on"){ print_r($e); };
				$msg=$e->getMessage()." by 録るメーラー";
				$msg=$msg."\r\n".$result["title"];
			}
		}
		$file=null;
		mailsend($return,"Re:".$request,$msg,$file);
	}

	//録画解約
	if(preg_match("/TV!(\s)?(\(.+\))?((\d+)時)?(.+)録らないで/", $request, $matches) == 1){
		$channel=$matches[2];
		$hour   =$matches[4];
		$title  =$matches[5];
		$type   =null;
		if($channel && preg_match("/\((\[(.+)\])?(.*)\)/", $channel, $matches)){
			$type = $matches[2];
			$channel = $matches[3];
		}
		
		$rpc = getRpc();
		$results = $rpc->searchProgram($title, $type, $channel, $hour);
		
		if(count($results) == 0){
			$msg="そんな番組ないよ！ by 録るメーラー";
		} else if(count($results) > 1){
			$msg="もっと詳しく！ by 録るメーラー";
		} else {
			$result = $results[0];
			try{
				$rpc->cancelreserveProgram($result["program_id"]);	
				$msg="解約したよ。 by 録るメーラー\r\n".$result["title"];
			} catch (Exception $e) {
				if(DEBUGSW=="on"){ print_r($e); };
				$msg=$e->getMessage()." by 録るメーラー";
				$msg=$msg."\r\n".$result["title"];
			}
		}
		$file=null;
		mailsend($return,"Re:".$request,$msg,$file);
	}

	//情報返信(TEXT)
	if(preg_match("/TV!(.+)教えて/", $request, $matches) == 1){
		if(DEBUGSW=="on"){ print($matches[1]."\n"); };
		$msg="";
		$write=false;
		if(mb_ereg("^番組*",$matches[1])){
			$files = fopen(EPGREC_URL."programTable.php", "r");
			while( ($line = fgetss($files, 1024 )) !== false) {
				$line=trim($line);
				if($line=="詳細録画"){
					$msg="番組のリストだよ by 録るメーラー\n";
					$write=true;
				}
				elseif(mb_ereg(".+件ヒット",$line)){ $write=false; }
				elseif($write and mb_ereg(".+",$line)){
					if($line=="GR" or $line=="CS" or $line=="BS"){
						$line="\n".$line;
					}
					$msg=$msg.$line."\n";
				}
			}
		}
		elseif(mb_ereg(".*予約*",$matches[1])){
			$files = fopen(EPGREC_URL."reservationTable.php", "r");
			while( ($line = fgetss($files, 1024 )) !== false) {
				$line=trim($line);
				if(($line=="GR" or $line=="CS" or $line=="BS") and $msg==""){
					$msg="録画予約中のリストだよ by 録るメーラー\n\n".$line."\n";
					$write=true;
				}
				elseif(mb_ereg("jQuery UI Dialog",$line)){ $write=false; }
				elseif($write and mb_ereg(".+",$line)){
					if($line=="GR" or $line=="CS" or $line=="BS"){
						$line="\n".$line;
					}
					$msg=$msg.$line."\n";
				}
			}
		}
		elseif(mb_ereg("^録画*",$matches[1])){
			$files = fopen(EPGREC_URL."recordedTable.php", "r");
			while( ($line = fgetss($files, 1024 )) !== false) {
				$line=trim($line);
				if(mb_ereg("[0-9]{4,}-[0-9]{2,}-[0-9]{2,} [0-9]{2,}:[0-9]{2,}:[0-9]{2,}",$line) and $msg==""){
					$msg="録画済みのリストだよ by 録るメーラー\n\n".$line."\n";
					$write=true;
				}
				elseif(mb_ereg("jQuery UI Dialog",$line)){ $write=false; }
				elseif($write and mb_ereg(".+",$line)){
					if(mb_ereg("[0-9]{4,}-[0-9]{2,}-[0-9]{2,} [0-9]{2,}:[0-9]{2,}:[0-9]{2,}",$line)){
						$line="\n".$line;
					}
					$msg=$msg.$line."\n";
				}
			}
		}
		else{
			$msg=file_get_contents(dirname(__FILE__)."/recbymail.help.txt");
		}
		$file=null;
		mailsend($return,"Re:".$request,$msg,$file);
	}

	//情報返信(HTMLファイル)
	if(preg_match("/TV!(.+)送って/", $request, $matches) == 1){
		if(DEBUGSW=="on"){ print($matches[1]."\n"); };
		if(mb_ereg("^番組表*",$matches[1])){
			$file=dirname(__FILE__)."/bangumihyou.html";
			file_put_contents($file,file_get_contents(EPGREC_URL."index.php"));
			$msg="番組表だよ　by 録るメーラー";
		}
		elseif(mb_ereg("^番組*",$matches[1])){
			$file=dirname(__FILE__)."/bangumi.html";
			file_put_contents($file,file_get_contents(EPGREC_URL."programTable.php"));
			$msg="番組一覧だよ　by 録るメーラー";
		}
		elseif(mb_ereg(".*予約*",$matches[1])){
			$file=dirname(__FILE__)."/yoyaku.html";
			file_put_contents($file,file_get_contents(EPGREC_URL."reservationTable.php"));
			$msg="録画予約一覧だよ　by 録るメーラー";
		}
		elseif(mb_ereg("^録画*",$matches[1])){
			$file=dirname(__FILE__)."/rokugazumi.html";
			file_put_contents($file,file_get_contents(EPGREC_URL."recordedTable.php"));
			$msg="録画済一覧だよ　by 録るメーラー";
		}
		else{
			$file=null;
			$msg="それはできないなぁ　by 録るメーラー";
		}
		mailsend($return,"Re:".$request,$msg,$file);
		if($file){ unlink($file); };
	}
}


//メール送信関数
function mailsend($to,$subject,$body,$attachfile){
	if(DEBUGSW=="on"){
		echo("--- mailsend ---\n");
		echo("TO     : ".$to."\n");
		echo("Subject: ".$subject."\n");
		echo("Body   : ".$body."\n");
		echo("Attach : ".$attachfile."\n");
		echo("----------------\n\n");
	}
	//日本語のエンコード
	$body = mb_convert_encoding($body,"iso-2022-jp");
	$subject=mb_encode_mimeheader(mb_convert_encoding($subject,"iso-2022-jp"));
	//SMTP接続
	$params = array(
	    "host"     => SMTP_HOST,
	    "port"     => SMTP_PORT,
	    "auth"     => true,
	    "username" => SMTP_USER,
	    "password" => SMTP_PSWD,
	    "debug"    => SMTP_DEBUG,
	);
	$smtp = Mail::factory("smtp", $params);
	//添付ファイル処理
	$mime = new Mail_Mime("\n");
	$mime->setTxtBody($body);
	$mime->addAttachment($attachfile,"application/octet-stream");
	$body_encode = array(
	    "head_charset" => "ISO-2022-JP",
	    "text_charset" => "ISO-2022-JP"
	);
	$body = $mime->get($body_encode);
	//ヘッダー生成
	$headers = array(
	    "To"      => $to,
	    "From"    => SMTP_FROM,
	    "Subject" => $subject,
	);
	$header = $mime->headers($headers);
	//送信実行
	$ret = $smtp->send($to, $header, $body);
	if ( PEAR::isError($ret) ) {
		echo("メール送信エラー：".$ret->getMessage()."\n");
	}
}

?>
