<?php
require_once dirname(__FILE__).'/abstractrpc.class.php';

//APIが正常終了してても例外を返す時があるので、とりあえず使わない。
class XmlRpc extends AbstractRpc{

	var $client;
	var $channelList = null;
	
	function XmlRpc(){
		require_once dirname(__FILE__).'/recbymail.config.php';
		require_once dirname(__FILE__).'/XML/RPC2/Client.php';
		
		//クライアント作成
		$options = array(
			"backend"  => "php",
			"encoding" => "UTF-8",
			"prefix" => "epgrec.",
		);
		$this->client = XML_RPC2_Client::create(EPGREC_URL.'xmlrpc.php', $options);
		$this->getChannelList();
	}
	
	public function searchProgram($keyword, $type, $channel, $hour){
		
		//$type = BS/CS/GR
		if($type){
			//チャンネルゲット
			if($channel != null){
				$channel_id = $this->getChannel($type, $channel);
				if($channel_id == null){
					return array();
				}
			}
		} else {
			$type = "*";
		}
		
		if($hour){
			//OK
		} else {
			$hour = 24;
		}
		
		//検索
		try {
		    $results = $this->client->searchProgram($keyword, false, $type, 0, $channel_id, 7, $hour);
		    //24時間以内で絞り込み
		    $tmp = array();
		    foreach($results as $result){
		    	if($result['starttime']->timestamp < $after24 = time() + (24 * 60 * 60)){
		    		$tmp[] = $result;
		    	} else {
		    		break;
		    	}
		    }
		    return $tmp;
		} catch (XML_RPC2_FaultException $e) {
		    die('Exception : ' . print_r($e, true));
		} catch (Exception $e) {
		    die('Exception : ' . print_r($e, true));
		}
	}
	
	function getChannelList(){
		if($this->channelList == null){
			$this->channelList = $this->client->getChannelList();
		}
	}
	
	function getChannel($type, $channel){
		foreach ($this->channelList as $tmp){
			if($tmp['type'] == $type && $tmp['name'] == $channel){
				return $tmp['channel_id'];
			}
		}
		return null;
	}
	
	public function reserveProgram($program_id){
	    $this->client->reserveProgram($program_id);
	}
	
	public function cancelreserveProgram($program_id){
	    $this->client->cancelreserveProgram($program_id);
	}
}


?>
